/*!The Treasure Box Library
 * 
 * TBox is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2.1 of the License, or
 * (at your option) any later version.
 * 
 * TBox is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with TBox; 
 * If not, see <a href="http://www.gnu.org/licenses/"> http://www.gnu.org/licenses/</a>
 * 
 * Copyright (C) 2009 - 2017, ruki All rights reserved.
 *
 * @author      ruki
 * @file        prefix.S
 *
 */

/* //////////////////////////////////////////////////////////////////////////////////////
 * includes
 */
#include "config.h"
#include "arch.h"
#include "cpu.h"
#include "endian.h"
#include "compiler.h"
#include "cache.h"
#if defined(TB_ARCH_x86)
#   include "x86/prefix.S"
#elif defined(TB_ARCH_x64)
#   include "x64/prefix.S"
#elif defined(TB_ARCH_ARM64)
#   include "arm64/prefix.S"
#elif defined(TB_ARCH_ARM)
#   include "arm/prefix.S"
#elif defined(TB_ARCH_MIPS)
#   include "mips/prefix.S"
#endif

